Browse Source

Revert "Bump OpenVPN to 4.4.5"

This reverts commit 3a07a7db1c019cf1405117fd5787382b1317e0f5.
RISCi_ATOM 6 years ago
parent
commit
f8cc0a4ff0

+ 2 - 3
package/network/services/openvpn/Makefile

@@ -9,14 +9,14 @@ include $(TOPDIR)/rules.mk
 
 PKG_NAME:=openvpn
 
-PKG_VERSION:=2.4.5
+PKG_VERSION:=2.4.4
 PKG_RELEASE:=3
 
 PKG_SOURCE_URL:=\
 	https://build.openvpn.net/downloads/releases/ \
 	https://swupdate.openvpn.net/community/releases/
 PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.xz
-PKG_HASH:=43c0a363a332350f620d1cd93bb431e082bedbc93d4fb872f758650d53c1d29e
+PKG_HASH:=96cd1b8fe1e8cb2920f07c3fd3985faea756e16fdeebd11d3e146d5bd2b04a80
 
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(BUILD_VARIANT)/$(PKG_NAME)-$(PKG_VERSION)
 PKG_MAINTAINER:=Felix Fietkau <nbd@nbd.name>
@@ -25,7 +25,6 @@ PKG_INSTALL:=1
 PKG_FIXUP:=autoreconf
 PKG_BUILD_PARALLEL:=1
 PKG_LICENSE:=GPL-2.0
-PKG_CPE_ID:=cpe:/a:openvpn:openvpn
 
 include $(INCLUDE_DIR)/package.mk
 

+ 407 - 0
package/network/services/openvpn/files/openvpn.config

@@ -0,0 +1,407 @@
+package openvpn
+
+#################################################
+# Sample to include a custom config file.       #
+#################################################
+
+config openvpn custom_config
+
+	# Set to 1 to enable this instance:
+	option enabled 0
+
+	# Include OpenVPN configuration
+	option config /etc/openvpn/my-vpn.conf
+
+
+#################################################
+# Sample OpenVPN 2.0 uci config for             #
+# multi-client server.                          #
+#################################################
+
+config openvpn sample_server
+
+	# Set to 1 to enable this instance:
+	option enabled 0
+
+	# Which local IP address should OpenVPN
+	# listen on? (optional)
+#	option local 0.0.0.0
+
+	# Which TCP/UDP port should OpenVPN listen on?
+	# If you want to run multiple OpenVPN instances
+	# on the same machine, use a different port
+	# number for each one.  You will need to
+	# open up this port on your firewall.
+	option port 1194
+
+	# TCP or UDP server?
+#	option proto tcp
+	option proto udp
+
+	# "dev tun" will create a routed IP tunnel,
+	# "dev tap" will create an ethernet tunnel.
+	# Use "dev tap0" if you are ethernet bridging
+	# and have precreated a tap0 virtual interface
+	# and bridged it with your ethernet interface.
+	# If you want to control access policies
+	# over the VPN, you must create firewall
+	# rules for the the TUN/TAP interface.
+	# On non-Windows systems, you can give
+	# an explicit unit number, such as tun0.
+	# On Windows, use "dev-node" for this.
+	# On most systems, the VPN will not function
+	# unless you partially or fully disable
+	# the firewall for the TUN/TAP interface.
+#	option dev tap
+	option dev tun
+
+	# SSL/TLS root certificate (ca), certificate
+	# (cert), and private key (key).  Each client
+	# and the server must have their own cert and
+	# key file.  The server and all clients will
+	# use the same ca file.
+	#
+	# See the "easy-rsa" directory for a series
+	# of scripts for generating RSA certificates
+	# and private keys.  Remember to use
+	# a unique Common Name for the server
+	# and each of the client certificates.
+	#
+	# Any X509 key management system can be used.
+	# OpenVPN can also use a PKCS #12 formatted key file
+	# (see "pkcs12" directive in man page).
+	option ca /etc/openvpn/ca.crt
+	option cert /etc/openvpn/server.crt
+	# This file should be kept secret:
+	option key /etc/openvpn/server.key
+
+	# Diffie hellman parameters.
+	# Generate your own with:
+	#   openssl dhparam -out dh1024.pem 1024
+	# Substitute 2048 for 1024 if you are using
+	# 2048 bit keys.
+	option dh /etc/openvpn/dh1024.pem
+
+	# Configure server mode and supply a VPN subnet
+	# for OpenVPN to draw client addresses from.
+	# The server will take 10.8.0.1 for itself,
+	# the rest will be made available to clients.
+	# Each client will be able to reach the server
+	# on 10.8.0.1. Comment this line out if you are
+	# ethernet bridging. See the man page for more info.
+	option server "10.8.0.0 255.255.255.0"
+
+	# Maintain a record of client <-> virtual IP address
+	# associations in this file.  If OpenVPN goes down or
+	# is restarted, reconnecting clients can be assigned
+	# the same virtual IP address from the pool that was
+	# previously assigned.
+	option ifconfig_pool_persist /tmp/ipp.txt
+
+	# Configure server mode for ethernet bridging.
+	# You must first use your OS's bridging capability
+	# to bridge the TAP interface with the ethernet
+	# NIC interface.  Then you must manually set the
+	# IP/netmask on the bridge interface, here we
+	# assume 10.8.0.4/255.255.255.0.  Finally we
+	# must set aside an IP range in this subnet
+	# (start=10.8.0.50 end=10.8.0.100) to allocate
+	# to connecting clients.  Leave this line commented
+	# out unless you are ethernet bridging.
+#	option server_bridge "10.8.0.4 255.255.255.0 10.8.0.50 10.8.0.100"
+
+	# Push routes to the client to allow it
+	# to reach other private subnets behind
+	# the server.  Remember that these
+	# private subnets will also need
+	# to know to route the OpenVPN client
+	# address pool (10.8.0.0/255.255.255.0)
+	# back to the OpenVPN server.
+#	list push "route 192.168.10.0 255.255.255.0"
+#	list push "route 192.168.20.0 255.255.255.0"
+
+	# To assign specific IP addresses to specific
+	# clients or if a connecting client has a private
+	# subnet behind it that should also have VPN access,
+	# use the subdirectory "ccd" for client-specific
+	# configuration files (see man page for more info).
+
+	# EXAMPLE: Suppose the client
+	# having the certificate common name "Thelonious"
+	# also has a small subnet behind his connecting
+	# machine, such as 192.168.40.128/255.255.255.248.
+	# First, uncomment out these lines:
+#	option client_config_dir /etc/openvpn/ccd
+#	list route "192.168.40.128 255.255.255.248"
+	# Then create a file ccd/Thelonious with this line:
+	#   iroute 192.168.40.128 255.255.255.248
+	# This will allow Thelonious' private subnet to
+	# access the VPN.  This example will only work
+	# if you are routing, not bridging, i.e. you are
+	# using "dev tun" and "server" directives.
+
+	# EXAMPLE: Suppose you want to give
+	# Thelonious a fixed VPN IP address of 10.9.0.1.
+	# First uncomment out these lines:
+#	option client_config_dir /etc/openvpn/ccd
+#	list route "10.9.0.0 255.255.255.252"
+#	list route "192.168.100.0 255.255.255.0"
+	# Then add this line to ccd/Thelonious:
+	#   ifconfig-push "10.9.0.1 10.9.0.2"
+
+	# Suppose that you want to enable different
+	# firewall access policies for different groups
+	# of clients.  There are two methods:
+	# (1) Run multiple OpenVPN daemons, one for each
+	#     group, and firewall the TUN/TAP interface
+	#     for each group/daemon appropriately.
+	# (2) (Advanced) Create a script to dynamically
+	#     modify the firewall in response to access
+	#     from different clients.  See man
+	#     page for more info on learn-address script.
+#	option learn_address /etc/openvpn/script
+
+	# If enabled, this directive will configure
+	# all clients to redirect their default
+	# network gateway through the VPN, causing
+	# all IP traffic such as web browsing and
+	# and DNS lookups to go through the VPN
+	# (The OpenVPN server machine may need to NAT
+	# the TUN/TAP interface to the internet in
+	# order for this to work properly).
+	# CAVEAT: May break client's network config if
+	# client's local DHCP server packets get routed
+	# through the tunnel.  Solution: make sure
+	# client's local DHCP server is reachable via
+	# a more specific route than the default route
+	# of 0.0.0.0/0.0.0.0.
+#	list push "redirect-gateway"
+
+	# Certain Windows-specific network settings
+	# can be pushed to clients, such as DNS
+	# or WINS server addresses.  CAVEAT:
+	# http://openvpn.net/faq.html#dhcpcaveats
+#	list push "dhcp-option DNS 10.8.0.1"
+#	list push "dhcp-option WINS 10.8.0.1"
+
+	# Uncomment this directive to allow different
+	# clients to be able to "see" each other.
+	# By default, clients will only see the server.
+	# To force clients to only see the server, you
+	# will also need to appropriately firewall the
+	# server's TUN/TAP interface.
+#	option client_to_client 1
+
+	# Uncomment this directive if multiple clients
+	# might connect with the same certificate/key
+	# files or common names.  This is recommended
+	# only for testing purposes.  For production use,
+	# each client should have its own certificate/key
+	# pair.
+	#
+	# IF YOU HAVE NOT GENERATED INDIVIDUAL
+	# CERTIFICATE/KEY PAIRS FOR EACH CLIENT,
+	# EACH HAVING ITS OWN UNIQUE "COMMON NAME",
+	# UNCOMMENT THIS LINE OUT.
+#	option duplicate_cn 1
+
+	# The keepalive directive causes ping-like
+	# messages to be sent back and forth over
+	# the link so that each side knows when
+	# the other side has gone down.
+	# Ping every 10 seconds, assume that remote
+	# peer is down if no ping received during
+	# a 120 second time period.
+	option keepalive "10 120"
+
+	# For extra security beyond that provided
+	# by SSL/TLS, create an "HMAC firewall"
+	# to help block DoS attacks and UDP port flooding.
+	#
+	# Generate with:
+	#   openvpn --genkey --secret ta.key
+	#
+	# The server and each client must have
+	# a copy of this key.
+	# The second parameter should be '0'
+	# on the server and '1' on the clients.
+	# This file is secret:
+#	option tls_auth "/etc/openvpn/ta.key 0"
+
+	# Select a cryptographic cipher.
+	# This config item must be copied to
+	# the client config file as well.
+	# Blowfish (default):
+#	option cipher BF-CBC
+	# AES:
+#	option cipher AES-128-CBC
+	# Triple-DES:
+#	option cipher DES-EDE3-CBC
+
+	# Enable compression on the VPN link.
+	# If you enable it here, you must also
+	# enable it in the client config file.
+	# LZ4 requires OpenVPN 2.4+ client and server
+#	option compress lz4
+	# LZO is compatible with most OpenVPN versions
+	# (set "compress lzo" on 2.4+ clients, and "comp-lzo yes" on older clients)
+	option compress lzo
+
+	# The maximum number of concurrently connected
+	# clients we want to allow.
+#	option max_clients 100
+
+	# The persist options will try to avoid
+	# accessing certain resources on restart
+	# that may no longer be accessible because
+	# of the privilege downgrade.
+	option persist_key 1
+	option persist_tun 1
+	option user nobody
+
+	# Output a short status file showing
+	# current connections, truncated
+	# and rewritten every minute.
+	option status /tmp/openvpn-status.log
+
+	# By default, log messages will go to the syslog (or
+	# on Windows, if running as a service, they will go to
+	# the "\Program Files\OpenVPN\log" directory).
+	# Use log or log-append to override this default.
+	# "log" will truncate the log file on OpenVPN startup,
+	# while "log-append" will append to it.  Use one
+	# or the other (but not both).
+#	option log         /tmp/openvpn.log
+#	option log_append  /tmp/openvpn.log
+
+	# Set the appropriate level of log
+	# file verbosity.
+	#
+	# 0 is silent, except for fatal errors
+	# 4 is reasonable for general usage
+	# 5 and 6 can help to debug connection problems
+	# 9 is extremely verbose
+	option verb 3
+
+	# Silence repeating messages.  At most 20
+	# sequential messages of the same message
+	# category will be output to the log.
+#	option mute 20
+
+
+##############################################
+# Sample client-side OpenVPN 2.0 uci config  #
+# for connecting to multi-client server.     #
+##############################################
+
+config openvpn sample_client
+
+	# Set to 1 to enable this instance:
+	option enabled 0
+
+	# Specify that we are a client and that we
+	# will be pulling certain config file directives
+	# from the server.
+	option client 1
+
+	# Use the same setting as you are using on
+	# the server.
+	# On most systems, the VPN will not function
+	# unless you partially or fully disable
+	# the firewall for the TUN/TAP interface.
+#	option dev tap
+	option dev tun
+
+	# Are we connecting to a TCP or
+	# UDP server?  Use the same setting as
+	# on the server.
+#	option proto tcp
+	option proto udp
+
+	# The hostname/IP and port of the server.
+	# You can have multiple remote entries
+	# to load balance between the servers.
+	list remote "my_server_1 1194"
+#	list remote "my_server_2 1194"
+
+	# Choose a random host from the remote
+	# list for load_balancing.  Otherwise
+	# try hosts in the order specified.
+#	option remote_random 1
+
+	# Keep trying indefinitely to resolve the
+	# host name of the OpenVPN server.  Very useful
+	# on machines which are not permanently connected
+	# to the internet such as laptops.
+	option resolv_retry infinite
+
+	# Most clients don't need to bind to
+	# a specific local port number.
+	option nobind 1
+
+	# Try to preserve some state across restarts.
+	option persist_key 1
+	option persist_tun 1
+	option user nobody
+
+	# If you are connecting through an
+	# HTTP proxy to reach the actual OpenVPN
+	# server, put the proxy server/IP and
+	# port number here.  See the man page
+	# if your proxy server requires
+	# authentication.
+	# retry on connection failures:
+#	option http_proxy_retry 1
+	# specify http proxy address and port:
+#	option http_proxy "192.168.1.100 8080"
+
+	# Wireless networks often produce a lot
+	# of duplicate packets.  Set this flag
+	# to silence duplicate packet warnings.
+#	option mute_replay_warnings 1
+
+	# SSL/TLS parms.
+	# See the server config file for more
+	# description.  It's best to use
+	# a separate .crt/.key file pair
+	# for each client.  A single ca
+	# file can be used for all clients.
+	option ca /etc/openvpn/ca.crt
+	option cert /etc/openvpn/client.crt
+	option key /etc/openvpn/client.key
+
+	# Verify server certificate by checking
+	# that the certicate has the nsCertType
+	# field set to "server".  This is an
+	# important precaution to protect against
+	# a potential attack discussed here:
+	#  http://openvpn.net/howto.html#mitm
+	#
+	# To use this feature, you will need to generate
+	# your server certificates with the nsCertType
+	# field set to "server".  The build_key_server
+	# script in the easy_rsa folder will do this.
+#	option ns_cert_type server
+
+	# If a tls_auth key is used on the server
+	# then every client must also have the key.
+#	option tls_auth "/etc/openvpn/ta.key 1"
+
+	# Select a cryptographic cipher.
+	# If the cipher option is used on the server
+	# then you must also specify it here.
+#	option cipher x
+
+	# Enable compression on the VPN link.
+	# Don't enable this unless it is also
+	# enabled in the server config file.
+	# LZ4 requires OpenVPN 2.4+ on server and client
+#	option compress lz4
+	# LZO is compatible with most OpenVPN versions
+	option compress lzo
+
+	# Set log file verbosity.
+	option verb 3
+
+	# Silence repeating messages
+#	option mute 20

+ 151 - 0
package/network/services/openvpn/files/openvpn.init

@@ -0,0 +1,151 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2008-2013 OpenWrt.org
+# Copyright (C) 2008 Jo-Philipp Wich
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+
+START=90
+STOP=10
+
+USE_PROCD=1
+PROG=/usr/sbin/openvpn
+
+LIST_SEP="
+"
+
+UCI_STARTED=
+UCI_DISABLED=
+
+append_param() {
+	local s="$1"
+	local v="$2"
+	case "$v" in
+		*_*_*_*) v=${v%%_*}-${v#*_}; v=${v%%_*}-${v#*_}; v=${v%%_*}-${v#*_} ;;
+		*_*_*)   v=${v%%_*}-${v#*_}; v=${v%%_*}-${v#*_} ;;
+		*_*)     v=${v%%_*}-${v#*_} ;;
+	esac
+	echo -n "$v" >> "/var/etc/openvpn-$s.conf"
+	return 0
+}
+
+append_bools() {
+	local p; local v; local s="$1"; shift
+	for p in $*; do
+		config_get_bool v "$s" "$p"
+		[ "$v" = 1 ] && append_param "$s" "$p" && echo >> "/var/etc/openvpn-$s.conf"
+	done
+}
+
+append_params() {
+	local p; local v; local s="$1"; shift
+	for p in $*; do
+		config_get v "$s" "$p"
+		IFS="$LIST_SEP"
+		for v in $v; do
+			[ -n "$v" ] && [ "$p" != "push" ] && append_param "$s" "$p" && echo " $v" >> "/var/etc/openvpn-$s.conf"
+			[ -n "$v" ] && [ "$p" == "push" ] && append_param "$s" "$p" && echo " \"$v\"" >> "/var/etc/openvpn-$s.conf"
+		done
+		unset IFS
+	done
+}
+
+section_enabled() {
+	config_get_bool enable  "$1" 'enable'  0
+	config_get_bool enabled "$1" 'enabled' 0
+	[ $enable -gt 0 ] || [ $enabled -gt 0 ]
+}
+
+openvpn_add_instance() {
+	local name="$1"
+	local dir="$2"
+	local conf="$3"
+
+	procd_open_instance "$name"
+	procd_set_param command "$PROG"	\
+		--syslog "openvpn($name)" \
+		--status "/var/run/openvpn.$name.status" \
+		--cd "$dir" \
+		--config "$conf"
+	procd_set_param file "$dir/$conf"
+	procd_set_param respawn
+	procd_append_param respawn 3600
+	procd_append_param respawn 5
+	procd_append_param respawn -1
+	procd_close_instance
+}
+
+start_instance() {
+	local s="$1"
+
+	config_get config "$s" config
+	config="${config:+$(readlink -f "$config")}"
+
+	section_enabled "$s" || {
+		append UCI_DISABLED "$config" "$LIST_SEP"
+		return 1
+	}
+
+	[ ! -d "/var/run" ] && mkdir -p "/var/run"
+
+	if [ ! -z "$config" ]; then
+		append UCI_STARTED "$config" "$LIST_SEP"
+		openvpn_add_instance "$s" "${config%/*}" "$config"
+		return
+	fi
+
+	[ ! -d "/var/etc" ] && mkdir -p "/var/etc"
+	[ -f "/var/etc/openvpn-$s.conf" ] && rm "/var/etc/openvpn-$s.conf"
+
+	append_bools "$s" $OPENVPN_BOOLS
+	append_params "$s" $OPENVPN_PARAMS
+
+	openvpn_add_instance "$s" "/var/etc" "openvpn-$s.conf"
+}
+
+start_service() {
+	local instance="$1"
+	local instance_found=0
+
+	config_cb() {
+		local type="$1"
+		local name="$2"
+		if [ "$type" = "openvpn" ]; then
+			if [ -n "$instance" -a "$instance" = "$name" ]; then
+				instance_found=1
+			fi
+		fi
+	}
+
+	. /usr/share/openvpn/openvpn.options
+	config_load 'openvpn'
+
+	if [ -n "$instance" ]; then
+		[ "$instance_found" -gt 0 ] || return
+		start_instance "$instance"
+	else
+		config_foreach start_instance 'openvpn'
+
+		local path name
+		for path in /etc/openvpn/*.conf; do
+			if [ -f "$path" ]; then
+				name="${path##*/}"; name="${name%.conf}"
+
+				# don't start configs again that are already started by uci
+				if echo "$UCI_STARTED" | grep -qxF "$path"; then
+					continue
+
+				# don't start configs which are set to disabled in uci
+				elif echo "$UCI_DISABLED" | grep -qxF "$path"; then
+					logger -t openvpn "$name.conf is disabled in /etc/config/openvpn"
+					continue
+				fi
+
+				openvpn_add_instance "$name" "${path%/*}" "$path"
+			fi
+		done
+	fi
+}
+
+service_triggers() {
+	procd_add_reload_trigger openvpn
+}

+ 7 - 1
package/network/services/openvpn/files/openvpn.options

@@ -14,6 +14,7 @@ cipher
 client_config_dir
 client_connect
 client_disconnect
+comp_lzo
 compress
 connect_freq
 connect_retry
@@ -131,7 +132,6 @@ txqueuelen
 up
 user
 verb
-verify_client_cert
 verify_x509_name
 x509_username_field
 '
@@ -143,6 +143,7 @@ auth_user_pass_optional
 bind
 ccd_exclusive
 client
+client_cert_not_required
 client_to_client
 comp_noadapt
 disable
@@ -154,6 +155,7 @@ float
 http_proxy_retry
 ifconfig_noexec
 ifconfig_nowarn
+ifconfig_pool_linear
 management_forget_disconnect
 management_hold
 management_query_passwords
@@ -165,6 +167,9 @@ multihome
 mute_replay_warnings
 ncp_disable
 nobind
+no_iv
+no_name_remapping
+no_replay
 opt_verify
 passtos
 persist_key
@@ -186,6 +191,7 @@ test_crypto
 tls_client
 tls_exit
 tls_server
+tun_ipv6
 up_delay
 up_restart
 username_as_common_name

+ 1 - 0
package/network/services/openvpn/files/openvpn.upgrade

@@ -0,0 +1 @@
+/etc/openvpn/

+ 10 - 0
package/network/services/openvpn/patches/001-reproducible-remove_DATE.patch

@@ -0,0 +1,10 @@
+--- a/src/openvpn/options.c
++++ b/src/openvpn/options.c
+@@ -106,7 +106,6 @@ const char title_string[] =
+ #ifdef HAVE_AEAD_CIPHER_MODES
+     " [AEAD]"
+ #endif
+-    " built on " __DATE__
+ ;
+ 
+ #ifndef ENABLE_SMALL

+ 1 - 1
package/network/services/openvpn/patches/100-mbedtls-disable-runtime-version-check.patch

@@ -1,6 +1,6 @@
 --- a/src/openvpn/ssl_mbedtls.c
 +++ b/src/openvpn/ssl_mbedtls.c
-@@ -1394,7 +1394,7 @@ const char *
+@@ -1336,7 +1336,7 @@ const char *
  get_ssl_library_version(void)
  {
      static char mbedtls_version[30];

+ 9 - 15
package/network/services/openvpn/patches/210-build_always_use_internal_lz4.patch

@@ -1,17 +1,15 @@
 --- a/configure.ac
 +++ b/configure.ac
-@@ -1077,68 +1077,15 @@ dnl
+@@ -1068,62 +1068,15 @@ dnl
  AC_ARG_VAR([LZ4_CFLAGS], [C compiler flags for lz4])
  AC_ARG_VAR([LZ4_LIBS], [linker flags for lz4])
  if test "$enable_lz4" = "yes" && test "$enable_comp_stub" = "no"; then
 -    if test -z "${LZ4_CFLAGS}" -a -z "${LZ4_LIBS}"; then
 -	# if the user did not explicitly specify flags, try to autodetect
 -	PKG_CHECK_MODULES([LZ4],
--			  [liblz4 >= 1.7.1 liblz4 < 100],
+-			  [liblz4 >= 1.7.1],
 -			  [have_lz4="yes"],
--			  [LZ4_LIBS="-llz4"] # If this fails, we will do another test next.
--					     # We also add set LZ4_LIBS otherwise the
--					     # linker will not know about the lz4 library
+-			  [] # If this fails, we will do another test next
 -	)
 -    fi
 
@@ -49,24 +47,20 @@
 -	fi
 -    fi
 -
--    # Double check we have a few needed functions
--    if test "${have_lz4}" = "yes" ; then
+-    # if LZ4_LIBS is set, we assume it will work, otherwise test
+-    if test -z "${LZ4_LIBS}"; then
 -	AC_CHECK_LIB([lz4],
--		     [LZ4_compress_default],
--		     [],
--		     [have_lz4="no"])
--	AC_CHECK_LIB([lz4],
--		     [LZ4_decompress_safe],
--		     [],
+-		     [LZ4_compress],
+-		     [LZ4_LIBS="-llz4"],
 -		     [have_lz4="no"])
 -    fi
 -
 -    if test "${have_lz4}" != "yes" ; then
--	AC_MSG_RESULT([		usable LZ4 library or header not found, using version in src/compat/compat-lz4.*])
+-	AC_MSG_RESULT([		usuable LZ4 library or header not found, using version in src/compat/compat-lz4.*])
 -	AC_DEFINE([NEED_COMPAT_LZ4], [1], [use copy of LZ4 source in compat/])
 -	LZ4_LIBS=""
 -    fi
-+    AC_MSG_RESULT([		usable LZ4 library or header not found, using version in src/compat/compat-lz4.*])
++    AC_MSG_RESULT([		usuable LZ4 library or header not found, using version in src/compat/compat-lz4.*])
 +    AC_DEFINE([NEED_COMPAT_LZ4], [1], [use copy of LZ4 source in compat/])
 +    LZ4_LIBS=""
      OPTIONAL_LZ4_CFLAGS="${LZ4_CFLAGS}"

+ 81 - 0
package/network/services/openvpn/patches/220-disable_des.patch

@@ -0,0 +1,81 @@
+--- a/src/openvpn/syshead.h
++++ b/src/openvpn/syshead.h
+@@ -597,11 +597,11 @@ socket_defined(const socket_descriptor_t
+ /*
+  * Should we include NTLM proxy functionality
+  */
+-#if defined(ENABLE_CRYPTO)
+-#define NTLM 1
+-#else
++//#if defined(ENABLE_CRYPTO)
++//#define NTLM 1
++//#else
+ #define NTLM 0
+-#endif
++//#endif
+ 
+ /*
+  * Should we include proxy digest auth functionality
+--- a/src/openvpn/crypto_mbedtls.c
++++ b/src/openvpn/crypto_mbedtls.c
+@@ -319,6 +319,7 @@ int
+ key_des_num_cblocks(const mbedtls_cipher_info_t *kt)
+ {
+     int ret = 0;
++#ifdef MBEDTLS_DES_C
+     if (kt->type == MBEDTLS_CIPHER_DES_CBC)
+     {
+         ret = 1;
+@@ -331,6 +332,7 @@ key_des_num_cblocks(const mbedtls_cipher
+     {
+         ret = 3;
+     }
++#endif
+ 
+     dmsg(D_CRYPTO_DEBUG, "CRYPTO INFO: n_DES_cblocks=%d", ret);
+     return ret;
+@@ -339,6 +341,7 @@ key_des_num_cblocks(const mbedtls_cipher
+ bool
+ key_des_check(uint8_t *key, int key_len, int ndc)
+ {
++#ifdef MBEDTLS_DES_C
+     int i;
+     struct buffer b;
+ 
+@@ -367,11 +370,15 @@ key_des_check(uint8_t *key, int key_len,
+ 
+ err:
+     return false;
++#else
++    return true;
++#endif
+ }
+ 
+ void
+ key_des_fixup(uint8_t *key, int key_len, int ndc)
+ {
++#ifdef MBEDTLS_DES_C
+     int i;
+     struct buffer b;
+ 
+@@ -386,6 +393,7 @@ key_des_fixup(uint8_t *key, int key_len,
+         }
+         mbedtls_des_key_set_parity(key);
+     }
++#endif
+ }
+ 
+ /*
+@@ -710,10 +718,12 @@ cipher_des_encrypt_ecb(const unsigned ch
+                        unsigned char *src,
+                        unsigned char *dst)
+ {
++#ifdef MBEDTLS_DES_C
+     mbedtls_des_context ctx;
+ 
+     ASSERT(mbed_ok(mbedtls_des_setkey_enc(&ctx, key)));
+     ASSERT(mbed_ok(mbedtls_des_crypt_ecb(&ctx, src, dst)));
++#endif
+ }
+ 
+